/**
 * BibleUp v.1.1.0
 * Copyright 2023-present BibleUp and contributors
 * Repository URL: https://github.com/Bibleup/bibleup.ts.git
 * Date: 27-03-2024
 */

var bibleData = [
    {
        book: 'Genesis',
        api: 'GEN',
        abbr: ['Gn', 'Ge', 'Gen'],
        id: 1,
        testament: 'OT',
        multipart: false,
        chapters: [
            31, 25, 24, 26, 32, 22, 24, 22, 29, 32, 32, 20, 18, 24, 21, 16, 27, 33,
            38, 18, 34, 24, 20, 67, 34, 35, 46, 22, 35, 43, 54, 33, 20, 31, 29, 43,
            36, 30, 23, 23, 57, 38, 34, 34, 28, 34, 31, 22, 33, 26
        ]
    },
    {
        book: 'Exodus',
        api: 'EXO',
        abbr: ['Ex', 'Exo', 'Exod'],
        id: 2,
        testament: 'OT',
        multipart: false,
        chapters: [
            22, 25, 22, 31, 23, 30, 29, 28, 35, 29, 10, 51, 22, 31, 27, 36, 16, 27,
            25, 26, 37, 30, 33, 18, 40, 37, 21, 43, 46, 38, 18, 35, 23, 35, 35, 38,
            29, 31, 43, 38
        ]
    },
    {
        book: 'Leviticus',
        api: 'LEV',
        abbr: ['Lev', 'Le', 'Lv'],
        id: 3,
        testament: 'OT',
        multipart: false,
        chapters: [
            17, 16, 17, 35, 26, 23, 38, 36, 24, 20, 47, 8, 59, 57, 33, 34, 16, 30, 37,
            27, 24, 33, 44, 23, 55, 46, 34
        ]
    },
    {
        book: 'Numbers',
        api: 'NUM',
        abbr: ['Num', 'Nu', 'Nm', 'Nb'],
        id: 4,
        testament: 'OT',
        multipart: false,
        chapters: [
            54, 34, 51, 49, 31, 27, 89, 26, 23, 36, 35, 16, 33, 45, 41, 35, 28, 32,
            22, 29, 35, 41, 30, 25, 19, 65, 23, 31, 39, 17, 54, 42, 56, 29, 34, 13
        ]
    },
    {
        book: 'Deuteronomy',
        api: 'DEU',
        abbr: ['Deut', 'Dt', 'De'],
        id: 5,
        testament: 'OT',
        multipart: false,
        chapters: [
            46, 37, 29, 49, 33, 25, 26, 20, 29, 22, 32, 31, 19, 29, 23, 22, 20, 22,
            21, 20, 23, 29, 26, 22, 19, 19, 26, 69, 28, 20, 30, 52, 29, 12
        ]
    },
    {
        book: 'Joshua',
        api: 'JOS',
        abbr: ['Josh', 'Jos', 'Jsh'],
        id: 6,
        testament: 'OT',
        multipart: false,
        chapters: [
            18, 24, 17, 24, 15, 27, 26, 35, 27, 43, 23, 24, 33, 15, 63, 10, 18, 28,
            51, 9, 45, 34, 16, 33
        ]
    },
    {
        book: 'Judges',
        api: 'JDG',
        abbr: ['Judg', 'Jdg', 'Jg', 'Jdgs'],
        id: 7,
        testament: 'OT',
        multipart: false,
        chapters: [
            36, 23, 31, 24, 31, 40, 25, 35, 57, 18, 40, 15, 25, 20, 20, 31, 13, 31,
            30, 48, 25
        ]
    },
    {
        book: 'Ruth',
        api: 'RUT',
        abbr: ['Rth', 'Ru'],
        id: 8,
        testament: 'OT',
        multipart: false,
        chapters: [22, 23, 18, 22]
    },
    {
        book: '1 Samuel',
        api: '1SA',
        abbr: [
            '1 Sam',
            '1 Sa',
            '1Samuel',
            'I Sa',
            '1 Sm',
            '1Sa',
            'I Sam',
            '1Sam',
            'I Samuel',
            '1st Samuel',
            'First Samuel'
        ],
        id: 9,
        testament: 'OT',
        multipart: true,
        chapters: [
            28, 36, 21, 22, 12, 21, 17, 22, 27, 27, 15, 25, 23, 52, 35, 23, 58, 30,
            24, 42, 16, 23, 28, 23, 43, 25, 12, 25, 11, 31, 13
        ]
    },
    {
        book: '2 Samuel',
        api: '2SA',
        id: 10,
        abbr: [
            '2 Sam',
            '2 Sa',
            'II Sa',
            '2 Sm',
            '2Sa',
            'II Sam',
            '2Sam',
            'II Samuel',
            '2Samuel',
            '2nd Samuel',
            'Second Samuel'
        ],
        testament: 'OT',
        multipart: true,
        chapters: [
            27, 32, 39, 12, 25, 23, 29, 18, 13, 19, 27, 31, 39, 33, 37, 23, 29, 32,
            44, 26, 22, 51, 39, 25
        ]
    },
    {
        book: '1 Kings',
        api: '1KI',
        abbr: [
            '1 Kgs',
            '1 Ki',
            'I Kgs',
            '1Kgs',
            'I Ki',
            '1Ki',
            'I Kings',
            '1Kings',
            '1st Kgs',
            '1st Kings',
            'First Kings',
            'First Kgs'
        ],
        id: 11,
        testament: 'OT',
        multipart: true,
        chapters: [
            53, 46, 28, 20, 32, 38, 51, 66, 28, 29, 43, 33, 34, 31, 34, 34, 24, 46,
            21, 43, 29, 54
        ]
    },
    {
        book: '2 Kings',
        api: '2KI',
        abbr: [
            '2 Kgs',
            '2 Ki',
            'II Kgs',
            '2Kgs',
            'II Ki',
            '2Ki',
            'II Kings',
            '2Kings',
            '2nd Kgs',
            '2nd Kings',
            'Second Kings',
            'Second Kgs'
        ],
        id: 12,
        testament: 'OT',
        multipart: true,
        chapters: [
            18, 25, 27, 44, 27, 33, 20, 29, 37, 36, 20, 22, 25, 29, 38, 20, 41, 37,
            37, 21, 26, 20, 37, 20, 30
        ]
    },
    {
        book: '1 Chronicles',
        api: '1CH',
        abbr: [
            '1 Chron',
            '1 Ch',
            'I Ch',
            '1Ch',
            '1 Chr',
            'I Chr',
            '1Chr',
            'I Chron',
            '1Chron',
            'I Chronicles',
            '1Chronicles',
            '1st Chronicles',
            'First Chronicles'
        ],
        id: 13,
        testament: 'OT',
        multipart: true,
        chapters: [
            54, 55, 24, 43, 41, 66, 40, 40, 44, 14, 47, 41, 14, 17, 29, 43, 27, 17,
            19, 8, 30, 19, 32, 31, 31, 32, 34, 21, 30
        ]
    },
    {
        book: '2 Chronicles',
        api: '2CH',
        abbr: [
            '2 Chron',
            '2 Ch',
            'II Ch',
            '2Ch',
            'II Chr',
            '2Chr',
            'II Chron',
            '2Chron',
            'II Chronicles',
            '2Chronicles',
            '2nd Chronicles',
            'Second Chronicles'
        ],
        id: 14,
        testament: 'OT',
        multipart: true,
        chapters: [
            18, 17, 17, 22, 14, 42, 22, 18, 31, 19, 23, 16, 23, 14, 19, 14, 19, 34,
            11, 37, 20, 12, 21, 27, 28, 23, 9, 27, 36, 27, 21, 33, 25, 33, 26, 23
        ]
    },
    {
        book: 'Ezra',
        api: 'EZR',
        abbr: ['Ezr'],
        id: 15,
        testament: 'OT',
        multipart: false,
        chapters: [11, 70, 13, 24, 17, 22, 28, 36, 15, 44]
    },
    {
        book: 'Nehemiah',
        api: 'NEH',
        abbr: ['Neh', 'Ne'],
        id: 16,
        testament: 'OT',
        multipart: false,
        chapters: [11, 20, 38, 17, 19, 19, 72, 18, 37, 40, 36, 47, 31]
    },
    {
        book: 'Esther',
        api: 'EST',
        abbr: ['Esth', 'Es', 'Est'],
        id: 17,
        testament: 'OT',
        multipart: false,
        chapters: [22, 23, 15, 17, 14, 14, 10, 17, 32, 3, 17, 8, 30, 16, 24, 10]
    },
    {
        book: 'Job',
        api: 'JOB',
        abbr: ['Jb'],
        id: 18,
        testament: 'OT',
        multipart: false,
        chapters: [
            22, 13, 26, 21, 27, 30, 21, 22, 35, 22, 20, 25, 28, 22, 35, 22, 16, 21,
            29, 29, 34, 30, 17, 25, 6, 14, 21, 28, 25, 31, 40, 22, 33, 37, 16, 33, 24,
            41, 30, 32, 26, 17
        ]
    },
    {
        book: 'Psalm',
        api: 'PSA',
        abbr: ['Pslm', 'Ps', 'Psalms', 'Psa', 'Psm', 'Pss'],
        id: 19,
        testament: 'OT',
        multipart: false,
        chapters: [
            6, 11, 9, 9, 13, 11, 18, 10, 21, 18, 7, 9, 6, 7, 5, 11, 15, 51, 15, 10,
            14, 32, 6, 10, 22, 11, 14, 9, 11, 13, 25, 11, 22, 23, 28, 13, 40, 23, 14,
            18, 14, 12, 5, 27, 18, 12, 10, 15, 21, 23, 21, 11, 7, 9, 24, 14, 12, 12,
            18, 14, 9, 13, 12, 11, 14, 20, 8, 36, 37, 6, 24, 20, 28, 23, 11, 13, 21,
            72, 13, 20, 17, 8, 19, 13, 14, 17, 7, 19, 53, 17, 16, 16, 5, 23, 11, 13,
            12, 9, 9, 5, 8, 29, 22, 35, 45, 48, 43, 14, 31, 7, 10, 10, 9, 8, 18, 19,
            2, 29, 176, 7, 8, 9, 4, 8, 5, 6, 5, 6, 8, 8, 3, 18, 3, 3, 21, 26, 9, 8,
            24, 14, 10, 8, 12, 15, 21, 10, 20, 14, 9, 6
        ]
    },
    {
        book: 'Proverbs',
        api: 'PRO',
        abbr: ['Prov', 'Pr', 'Prv'],
        id: 20,
        testament: 'OT',
        multipart: false,
        chapters: [
            33, 22, 35, 27, 23, 35, 27, 36, 18, 32, 31, 28, 25, 35, 33, 33, 28, 24,
            29, 30, 31, 29, 35, 34, 28, 28, 27, 28, 27, 33, 31
        ]
    },
    {
        book: 'Ecclesiastes',
        api: 'ECC',
        abbr: ['Eccles', 'Eccl', 'Ec', 'Ecc'],
        id: 21,
        testament: 'OT',
        multipart: false,
        chapters: [18, 26, 22, 17, 19, 12, 29, 17, 18, 20, 10, 14]
    },
    {
        book: 'Song of Solomon',
        api: 'SNG',
        // prettier-ignore
        abbr: [
            'Song',
            'So',
            'Canticle of Canticles',
            'Canticles',
            'Song of Songs',
            'SOS'
        ],
        id: 22,
        testament: 'OT',
        multipart: false,
        chapters: [17, 17, 11, 16, 16, 12, 14, 14]
    },
    {
        book: 'Isaiah',
        api: 'ISA',
        abbr: ['Isa', 'Is'],
        id: 23,
        testament: 'OT',
        multipart: false,
        chapters: [
            31, 22, 26, 6, 30, 13, 25, 23, 20, 34, 16, 6, 22, 32, 9, 14, 14, 7, 25, 6,
            17, 25, 18, 23, 12, 21, 13, 29, 24, 33, 9, 20, 24, 17, 10, 22, 38, 22, 8,
            31, 29, 25, 28, 28, 25, 13, 15, 22, 26, 11, 23, 15, 12, 17, 13, 12, 21,
            14, 21, 22, 11, 12, 19, 11, 25, 24
        ]
    },
    {
        book: 'Jeremiah',
        api: 'JER',
        abbr: ['Jer', 'Je', 'Jr'],
        id: 24,
        testament: 'OT',
        multipart: false,
        chapters: [
            19, 37, 25, 31, 31, 30, 34, 23, 25, 25, 23, 17, 27, 22, 21, 21, 27, 23,
            15, 18, 14, 30, 40, 10, 38, 24, 22, 17, 32, 24, 40, 44, 26, 22, 19, 32,
            21, 28, 18, 16, 18, 22, 13, 30, 5, 28, 7, 47, 39, 46, 64, 34
        ]
    },
    {
        book: 'Lamentations',
        api: 'LAM',
        abbr: ['Lam', 'La'],
        id: 25,
        testament: 'OT',
        multipart: false,
        chapters: [22, 22, 66, 22, 22]
    },
    {
        book: 'Ezekiel',
        api: 'EZK',
        abbr: ['Ezek', 'Eze', 'Ezk'],
        id: 26,
        testament: 'OT',
        multipart: false,
        chapters: [
            28, 10, 27, 17, 17, 14, 27, 18, 11, 22, 25, 28, 23, 23, 8, 63, 24, 32, 14,
            44, 37, 31, 49, 27, 17, 21, 36, 26, 21, 26, 18, 32, 33, 31, 15, 38, 28,
            23, 29, 49, 26, 20, 27, 31, 25, 24, 23, 35
        ]
    },
    {
        book: 'Daniel',
        api: 'DAN',
        abbr: ['Dan', 'Da', 'Dn'],
        id: 27,
        testament: 'OT',
        multipart: false,
        chapters: [21, 49, 30, 37, 31, 28, 28, 27, 27, 21, 45, 13]
    },
    {
        book: 'Hosea',
        api: 'HOS',
        abbr: ['Hos', 'Ho'],
        id: 28,
        testament: 'OT',
        multipart: false,
        chapters: [9, 25, 5, 19, 15, 11, 16, 14, 17, 15, 11, 15, 15, 10]
    },
    {
        book: 'Joel',
        api: 'JOL',
        abbr: ['Joe', 'Jl'],
        id: 29,
        testament: 'OT',
        multipart: false,
        chapters: [20, 27, 5, 21]
    },
    {
        book: 'Amos',
        api: 'AMO',
        abbr: ['Am'],
        id: 30,
        testament: 'OT',
        multipart: false,
        chapters: [15, 16, 15, 13, 27, 14, 17, 14, 15]
    },
    {
        book: 'Obadiah',
        api: 'OBA',
        abbr: ['Obad', 'Ob'],
        id: 31,
        testament: 'OT',
        multipart: false,
        chapters: [21]
    },
    {
        book: 'Jonah',
        api: 'JON',
        abbr: ['Jnh', 'Jon'],
        id: 32,
        testament: 'OT',
        multipart: false,
        chapters: [16, 11, 10, 11]
    },
    {
        book: 'Micah',
        api: 'MIC',
        abbr: ['Mic'],
        id: 33,
        testament: 'OT',
        multipart: false,
        chapters: [16, 13, 12, 14, 14, 16, 20]
    },
    {
        book: 'Nahum',
        api: 'NAM',
        abbr: ['Nah', 'Na'],
        id: 34,
        testament: 'OT',
        multipart: false,
        chapters: [14, 14, 19]
    },
    {
        book: 'Habakkuk',
        api: 'HAB',
        abbr: ['Hab'],
        id: 35,
        testament: 'OT',
        multipart: false,
        chapters: [17, 20, 19]
    },
    {
        book: 'Zephaniah',
        api: 'ZEP',
        abbr: ['Zeph', 'Zep', 'Zp'],
        id: 36,
        testament: 'OT',
        multipart: false,
        chapters: [18, 15, 20]
    },
    {
        book: 'Haggai',
        api: 'HAG',
        abbr: ['Hag', 'Hg'],
        id: 37,
        testament: 'OT',
        multipart: false,
        chapters: [15, 23]
    },
    {
        book: 'Zechariah',
        api: 'ZEC',
        abbr: ['Zech', 'Zec', 'Zc'],
        id: 38,
        testament: 'OT',
        multipart: false,
        chapters: [17, 17, 10, 14, 11, 15, 14, 23, 17, 12, 17, 14, 9, 21]
    },
    {
        book: 'Malachi',
        api: 'MAL',
        abbr: ['Mal', 'Ml'],
        id: 39,
        testament: 'OT',
        multipart: false,
        chapters: [14, 17, 24]
    },
    {
        book: 'Matthew',
        api: 'MAT',
        abbr: ['Matt', 'Mt'],
        id: 40,
        testament: 'NT',
        multipart: false,
        chapters: [
            25, 23, 17, 25, 48, 34, 29, 34, 38, 42, 30, 50, 58, 36, 39, 28, 27, 35,
            30, 34, 46, 46, 39, 51, 46, 75, 66, 20
        ]
    },
    {
        book: 'Mark',
        api: 'MRK',
        abbr: ['Mrk', 'Mk'],
        id: 41,
        testament: 'NT',
        multipart: false,
        chapters: [45, 28, 35, 41, 43, 56, 37, 38, 50, 52, 33, 44, 37, 72, 47, 20]
    },
    {
        book: 'Luke',
        api: 'LUK',
        abbr: ['Luk', 'Lk'],
        id: 42,
        testament: 'NT',
        multipart: false,
        chapters: [
            80, 52, 38, 44, 39, 49, 50, 56, 62, 42, 54, 59, 35, 35, 32, 31, 37, 43,
            48, 47, 38, 71, 56, 53
        ]
    },
    {
        book: 'John',
        api: 'JHN',
        abbr: ['Jhn', 'Jn'],
        id: 43,
        testament: 'NT',
        multipart: false,
        chapters: [
            51, 25, 36, 54, 47, 71, 53, 59, 41, 42, 57, 50, 38, 31, 27, 33, 26, 40,
            42, 31, 25
        ]
    },
    {
        book: 'Acts',
        api: 'ACT',
        abbr: ['Ac'],
        id: 44,
        testament: 'NT',
        multipart: false,
        chapters: [
            26, 47, 26, 37, 42, 15, 60, 40, 43, 48, 30, 25, 52, 28, 41, 40, 34, 28,
            41, 38, 40, 30, 35, 27, 27, 32, 44, 31
        ]
    },
    {
        book: 'Romans',
        api: 'ROM',
        abbr: ['Rom', 'Ro', 'Rm'],
        id: 45,
        testament: 'NT',
        multipart: false,
        chapters: [32, 29, 31, 25, 21, 23, 25, 39, 33, 21, 36, 21, 14, 23, 33, 27]
    },
    {
        book: '1 Corinthians',
        api: '1CO',
        abbr: [
            '1 Cor',
            '1 Co',
            'I Co',
            '1Co',
            'I Cor',
            '1Cor',
            'I Corinthians',
            '1Corinthians',
            '1st Corinthians',
            'First Corinthians'
        ],
        id: 46,
        testament: 'NT',
        multipart: true,
        chapters: [31, 16, 23, 21, 13, 20, 40, 13, 27, 33, 34, 31, 13, 40, 58, 24]
    },
    {
        book: '2 Corinthians',
        api: '2CO',
        abbr: [
            '2 Cor',
            '2 Co',
            'II Co',
            '2Co',
            'II Cor',
            '2Cor',
            'II Corinthians',
            '2Corinthians',
            '2nd Corinthians',
            'Second Corinthians'
        ],
        id: 47,
        testament: 'NT',
        multipart: true,
        chapters: [24, 17, 18, 18, 21, 18, 16, 24, 15, 18, 33, 21, 14]
    },
    {
        book: 'Galatians',
        api: 'GAL',
        abbr: ['Gal', 'Ga'],
        id: 48,
        testament: 'NT',
        multipart: false,
        chapters: [24, 21, 29, 31, 26, 18]
    },
    {
        book: 'Ephesians',
        api: 'EPH',
        abbr: ['Ephes', 'Eph'],
        id: 49,
        testament: 'NT',
        multipart: false,
        chapters: [23, 22, 21, 32, 33, 24]
    },
    {
        book: 'Philippians',
        api: 'PHP',
        abbr: ['Phil', 'Php'],
        id: 50,
        testament: 'NT',
        multipart: false,
        chapters: [30, 30, 21, 23]
    },
    {
        book: 'Colossians',
        api: 'COL',
        abbr: ['Col'],
        id: 51,
        testament: 'NT',
        multipart: false,
        chapters: [29, 23, 25, 18]
    },
    {
        book: '1 Thessalonians',
        api: '1TH',
        abbr: [
            '1 Thess',
            '1 Th',
            'I Th',
            '1Th',
            'I Thes',
            '1Thes',
            'I Thess',
            '1Thess',
            'I Thessalonians',
            '1Thessalonians',
            '1st Thessalonians',
            'First Thessalonians'
        ],
        id: 52,
        testament: 'NT',
        multipart: true,
        chapters: [10, 20, 13, 18, 28]
    },
    {
        book: '2 Thessalonians',
        api: '2TH',
        abbr: [
            '2 Thess',
            '2 Th',
            'II Th',
            '2Th',
            'II Thes',
            '2Thes',
            'II Thess',
            '2Thess',
            'II Thessalonians',
            '2Thessalonians',
            '2nd Thessalonians',
            'Second Thessalonians'
        ],
        id: 53,
        testament: 'NT',
        multipart: true,
        chapters: [12, 17, 18]
    },
    {
        book: '1 Timothy',
        api: '1TI',
        abbr: [
            '1 Tim',
            '1 Ti',
            'I Ti',
            '1Ti',
            'I Tim',
            '1Tim',
            'I Timothy',
            '1Timothy',
            '1st Timothy',
            'First Timothy'
        ],
        id: 54,
        testament: 'NT',
        multipart: true,
        chapters: [20, 15, 16, 16, 25, 21]
    },
    {
        book: '2 Timothy',
        api: '2TI',
        abbr: [
            '2 Tim',
            '2 Ti',
            'II Ti',
            '2Ti',
            'II Tim',
            '2Tim',
            'II Timothy',
            '2Timothy',
            '2nd Timothy',
            'Second Timothy'
        ],
        id: 55,
        testament: 'NT',
        multipart: true,
        chapters: [18, 26, 17, 22]
    },
    {
        book: 'Titus',
        api: 'TIT',
        abbr: ['Tit', 'Ti'],
        id: 56,
        testament: 'NT',
        multipart: false,
        chapters: [16, 15, 15]
    },
    {
        book: 'Philemon',
        api: 'PHM',
        abbr: ['Philem', 'Phlm', 'Phm'],
        id: 57,
        testament: 'NT',
        multipart: false,
        chapters: [25]
    },
    {
        book: 'Hebrews',
        api: 'HEB',
        abbr: ['Heb'],
        id: 58,
        testament: 'NT',
        multipart: false,
        chapters: [14, 18, 19, 16, 14, 20, 28, 13, 28, 39, 40, 29, 25]
    },
    {
        book: 'James',
        api: 'JAS',
        abbr: ['Jas', 'Jm'],
        id: 59,
        testament: 'NT',
        multipart: false,
        chapters: [27, 26, 18, 17, 20]
    },
    {
        book: '1 Peter',
        api: '1PE',
        abbr: [
            '1 Pet',
            '1 Pe',
            'I Pe',
            '1Pe',
            'I Pet',
            '1Pet',
            'I Pt',
            '1 Pt',
            '1Pt',
            'I Peter',
            '1Peter',
            '1st Peter',
            'First Peter'
        ],
        id: 60,
        testament: 'NT',
        multipart: true,
        chapters: [25, 25, 22, 19, 14]
    },
    {
        book: '2 Peter',
        api: '2PE',
        abbr: [
            '2 Pet',
            '2 Pe',
            'II Pe',
            '2Pe',
            'II Pet',
            '2Pet',
            'II Pt',
            '2 Pt',
            '2Pt',
            'II Peter',
            '2Peter',
            '2nd Peter',
            'Second Peter'
        ],
        id: 61,
        testament: 'NT',
        multipart: true,
        chapters: [21, 22, 18]
    },
    {
        book: '1 John',
        api: '1JN',
        abbr: [
            '1 Jn',
            'I Jn',
            '1Jn',
            'I Jo',
            '1Jo',
            'I Joh',
            '1Joh',
            'I Jhn',
            '1 Jhn',
            '1Jhn',
            'I John',
            '1John',
            '1st John',
            'First John'
        ],
        id: 62,
        testament: 'NT',
        multipart: true,
        chapters: [10, 29, 24, 21, 21]
    },
    {
        book: '2 John',
        api: '2JN',
        abbr: [
            '2 Jn',
            'II Jn',
            '2Jn',
            'II Jo',
            '2Jo',
            'II Joh',
            '2Joh',
            'II Jhn',
            '2 Jhn',
            '2Jhn',
            'II John',
            '2John',
            '2nd John',
            'Second John'
        ],
        id: 63,
        testament: 'NT',
        multipart: true,
        chapters: [13]
    },
    {
        book: '3 John',
        api: '3JN',
        abbr: [
            '3 Jn',
            'III Jn',
            '3Jn',
            'III Jo',
            '3Jo',
            'III Joh',
            '3Joh',
            'III Jhn',
            '3 Jhn',
            '3Jhn',
            'III John',
            '3John',
            '3rd John',
            'Third John'
        ],
        id: 64,
        testament: 'NT',
        multipart: true,
        chapters: [15]
    },
    {
        book: 'Jude',
        api: 'JUD',
        abbr: ['Jud', 'Jd'],
        id: 65,
        testament: 'NT',
        multipart: false,
        chapters: [25]
    },
    {
        book: 'Revelation',
        api: 'REV',
        abbr: ['Rev', 'The Revelation'],
        id: 66,
        testament: 'NT',
        multipart: false,
        chapters: [
            20, 29, 22, 11, 14, 17, 17, 13, 21, 11, 19, 17, 18, 20, 8, 21, 18, 24, 21,
            15, 27, 21
        ]
    }
];

/**
 * @return All book names and abbreviations separated by '|'
 * - Multipart books include 1st John, 2nd John, etc.
 */
const allAbbreviations = () => {
    const result = [];
    const multipart = [];
    for (const book of bibleData) {
        result.push(book.book, ...book.abbr);
        if (book.multipart) {
            multipart.push(book.book, ...book.abbr);
        }
    }
    return {
        all: result.join('|'),
        multipart: multipart.join('|')
    };
};
/**
 * @returns The book ID for a particular Bible book
 * - accepts standard book - 'Psalm'
 * - returns ID - 19
 */
const getBookId = (book) => {
    const bible = bibleData.find((bible) => bible.book === book);
    return bible ? bible.id : undefined;
};
/**
 * An object of supported Bible versions.
 * @description Each property is an array of versions named after the api service
 * from which the versions are fetched
 * @property bibleApi - Versions to be fetched through api.bible
 * @property bolls - Versions to be fetched through Bolls
 */
const supportedVersions = {
    bibleApi: ['KJV', 'ASV', 'LSV', 'WEB'],
    bolls: ['ESV', 'NIV', 'MSG', 'NLT', 'AMP', 'NASB'],
    get all() {
        return [...this.bolls, ...this.bibleApi];
    }
};
/**
 * @returns The abbreviated book name recognised by api.bible
 * - accepts standard book - 'Psalm'
 * - returns abbr book for API/URL - 'PSA'
 */
const getAPIBook = (book) => {
    const bible = bibleData.find((bible) => bible.book === book);
    return bible ? bible.api : undefined;
};
/**
 * @returns The real standard book name from an abbreviation
 * e.g Jn or jn returns John, gen returns Genesis
 */
const realBook = (abbr) => {
    abbr = abbr.toLowerCase();
    for (const data of bibleData) {
        const abbrList = data.abbr.map((element) => element.toLowerCase());
        if (abbrList.includes(abbr) || data.book.toLowerCase() === abbr) {
            return data.book;
        }
    }
    return 'undefined';
};
/**
 * Converts object of Type BibleData into a complete Bible props object
 * @Returns BibleRef or false
 */
const extractPassage = (bibleData) => {
    const book = realBook(bibleData.book);
    let apiBook = getAPIBook(book);
    const chapter = parseInt(bibleData.chapter);
    let verse = parseInt(bibleData.verse) || 1;
    let verseEnd = parseInt(bibleData.verseEnd) || undefined;
    if (apiBook === undefined) {
        return false;
    }
    // swap value of verse and verseEnd
    if (verseEnd !== undefined && verse > verseEnd) {
        [verse, verseEnd] = [verseEnd, verse];
    }
    // complete reference
    let ref;
    if (verseEnd === undefined) {
        ref = `${book} ${chapter}:${verse}`;
        apiBook = `${apiBook}.${chapter}.${verse}`;
    }
    else {
        ref = `${book} ${chapter}:${verse}-${verseEnd}`;
        apiBook = `${apiBook}.${chapter}.${verse}-${apiBook}.${chapter}.${verseEnd}`;
    }
    return {
        ref,
        book,
        chapter,
        verse,
        verseEnd,
        apiBook
    };
};

/**
 * Constructs BibleUp popup according to options and append to Dom
 * @param options BibleUp Option
 * @param buid BibleUp ID
 * @type Popup
 */
const build = (options, buid) => {
    const popup = document.createElement('div');
    popup.id = `bu-popup-${buid}`;
    popup.classList.add('bu-popup-hide', 'bu-ignore');
    const popupStyle = options.popup;
    const darkTheme = options.darkTheme;
    // Accessibility
    popup.setAttribute('role', 'dialog');
    popup.setAttribute('aria-description', 'A non-modal popover showing the text of Bible reference');
    switch (popupStyle) {
        case 'classic':
            popup.classList.add('bu-classic');
            popup.innerHTML = classic();
            break;
        case 'inline':
            popup.classList.add('bu-inline');
            popup.innerHTML = inline();
            break;
        case 'wiki':
            popup.classList.add('bu-wiki');
            popup.innerHTML = wiki();
            break;
    }
    if (darkTheme === true) {
        popup.setAttribute('data-bu-theme', 'dark');
    }
    document.body.appendChild(popup);
    return referenceDOM(buid);
};
const referenceDOM = (buid) => {
    return {
        container: document.getElementById(`bu-popup-${buid}`),
        header: document.querySelector(`#bu-popup-${buid} .bu-popup-header`),
        ref: document.querySelector(`#bu-popup-${buid} .bu-popup-ref`),
        version: document.querySelector(`#bu-popup-${buid} .bu-popup-version`),
        content: document.querySelector(`#bu-popup-${buid} .bu-popup-content`),
        text: document.querySelector(`#bu-popup-${buid} .bu-popup-text`),
        close: document.querySelector(`#bu-popup-${buid} .bu-popup-close`) || null
    };
};
const classic = () => {
    const markup = `
		<div class='bu-popup-header'>
		<p class='bu-popup-ref'></p>
		<p class="bu-popup-version"></p>
		</div>

		<div class='bu-popup-content'>
			<ol class='bu-popup-text'></ol>
		</div>

		<div class='bu-popup-footer'>
			<p>BibleUp 📖💡 </p>
		</div>
		`;
    return markup;
};
const wiki = () => {
    const markup = `
	 <div class='bu-popup-header'>
	  <p class='bu-popup-ref'></p>
	  <span class='bu-popup-version'></span>
	  <button class='bu-popup-close' tabindex='0'>&#x2715</button>
	 </div>

	 <div class='bu-popup-content'>
	 	<ol class='bu-popup-text'></ol>
	 </div>

	 <div class='bu-popup-footer'>
	 	<p>BibleUp 📖💡 </p>
	 </div>`;
    return markup;
};
const inline = () => {
    const markup = `
		<div class='bu-popup-content'>
  			<ol class='bu-popup-text'></ol>
  		</div>

 		<div class='bu-popup-footer'>
  			<p>BibleUp 📖💡 </p>
 		</div>`;
    return markup;
};

/**
 * positionPopup() calls positional codes for popup and sets the popup new positions
 * - NOTE - the popup dimensions(height, width) can only be gotten when using 'visibility:hidden' and not
 * 'display:none'
 */
const positionPopup = (e, popup, container) => {
    const el = getPosition(e, container);
    if (popup === 'inline') {
        el.popWidth += 10;
    }
    if (popup !== 'wiki') {
        adjustPopupToLeft(container, [el.width, el.rectLeft, el.popWidth]);
        adjustPopupToBottom(container, [
            el.height,
            el.rectBottom,
            el.popHeight,
            el.realTop,
            el.rect.height
        ]);
    }
};
/**
 * Adjust popup to left or right of click
 */
const adjustPopupToLeft = (el, pos) => {
    const [width, rectLeft, popWidth] = pos;
    const remainingSpace = width - rectLeft;
    if (remainingSpace > popWidth) {
        if (rectLeft < 0) {
            el.style.left = `${0}px`;
        }
        else {
            el.style.left = `${rectLeft}px`;
        }
    }
    else {
        const offsetBy = popWidth - remainingSpace;
        const adjust = rectLeft - offsetBy;
        el.style.left = `${adjust}px`;
    }
};
/**
 * Adjust popup to bottom or top of link according to space remaining
 * - Popup appears on top of link by default and fallbacks to bottom if there is no space.
 */
const adjustPopupToBottom = (el, pos) => {
    const [height, rectBottom, popHeight, realTop, rectHeight] = pos;
    const bottomSpace = height - rectBottom;
    const topSpace = height - bottomSpace;
    if (topSpace > popHeight + 50) {
        const adjust = realTop - popHeight;
        el.style.top = `${adjust - 5}px`;
    }
    else {
        el.style.top = `${realTop + (rectHeight + 5)}px`;
    }
};
const getPosition = (e, container) => {
    // get window dimensions
    const rect = e.target.getBoundingClientRect();
    const popup = container;
    const rectTop = rect.top;
    return {
        rect,
        rectTop,
        height: window.innerHeight,
        width: document.documentElement.clientWidth,
        popWidth: popup.offsetWidth,
        popHeight: popup.offsetHeight,
        rectBottom: rect.bottom,
        rectLeft: Math.round(rect.left),
        realTop: window.scrollY + rectTop
    };
};

const apiKey = '7e0a787b68dd07720fa1200b67f2d483';

/**
 * get scripture Text from bible reference
 * - @returns BibleFetch
 * - if text returns null, there was problem fetching the Bible text, else text is an array with Bible texts
 */
const getScripture = async (bible, version) => {
    let text;
    const versionId = getVersionId(version);
    const isPassage = bible.verseEnd ? true : false;
    if (versionId === version.toUpperCase()) {
        //BOLLS VERSION
        text = await fetchBolls(isPassage, bible, versionId);
    }
    else {
        text = await fetchBibleApi(isPassage, bible.apiBook, versionId);
    }
    const result = {
        ref: bible.ref,
        version: version.toUpperCase(),
        refData: {
            book: bible.book,
            chapter: bible.chapter,
            startVerse: bible.verse,
            endVerse: bible.verseEnd
        },
        apiBook: bible.apiBook,
        text
    };
    return result;
};
const getVersionId = (version) => {
    let id;
    const BOLLS_VERSION = supportedVersions.bolls;
    if (BOLLS_VERSION.includes(version.toUpperCase())) {
        return version.toUpperCase();
    }
    switch (version.toUpperCase()) {
        case 'KJV':
            id = 'de4e12af7f28f599-01';
            break;
        case 'ASV':
            id = '06125adad2d5898a-01';
            break;
        case 'LSV':
            id = '01b29f4b342acc35-01';
            break;
        case 'WEB':
            id = '9879dbb7cfe39e4d-01';
            break;
        default:
            id = 'de4e12af7f28f599-01';
    }
    return id;
};
const fetchBibleApi = async (isPassage, apiBook, versionId) => {
    const type = isPassage ? 'passages' : 'verses';
    const typePayload = isPassage
        ? 'include-verse-spans=true'
        : 'include-verse-spans=false';
    const url = `https://api.scripture.api.bible/v1/bibles/${versionId}/${type}/${apiBook}?content-type=html&include-notes=false&include-titles=false&include-chapter-numbers=false&include-verse-numbers=false&${typePayload}&use-org-id=false`;
    try {
        const res = await fetch(url, {
            method: 'GET',
            cache: 'force-cache',
            headers: {
                'api-key': apiKey
            }
        });
        if (!res.ok) {
            throw new Error('A problem occured while fetching data');
        }
        const content = (await res.json());
        return processBibleText(content, type);
    }
    catch (error) {
        return null;
    }
};
const fetchBolls = async (isPassage, bible, versionId) => {
    const url = 'https://bolls.life/get-verses/';
    const verses = [];
    if (isPassage && bible.verseEnd) {
        for (let i = bible.verse; i <= bible.verseEnd; i++) {
            verses.push(i);
        }
    }
    else {
        verses.push(bible.verse);
    }
    try {
        const res = await fetch(url, {
            method: 'POST',
            cache: 'force-cache',
            body: JSON.stringify([
                {
                    translation: versionId,
                    book: getBookId(bible.book),
                    chapter: bible.chapter,
                    verses
                }
            ])
        });
        if (!res.ok) {
            throw new Error('A problem occured while fetching data');
        }
        const content = (await res.json());
        const text = [];
        for (const obj of content[0]) {
            text.push(obj.text);
        }
        return text;
    }
    catch (error) {
        return null;
    }
};
/**
 * parses HTML response from the fetch API and extract the verses.
 * - WARNING: The HTML responses are tricky and had to be parsed based on observations from manual testing
 * - if type is `verses`, it returns array with single value ['Jesus be Glorified']
 * - if type is  `passages`, it returns array of values ['Jesus be Glorified', 'Forever']
 */
const processBibleText = (res, type) => {
    const result = [];
    if (type === 'verses') {
        const parser = new DOMParser();
        const doc = parser.parseFromString(res.data.content, 'text/html');
        const p = doc.querySelectorAll('p');
        result.push(p[0].textContent || p[1].textContent || 'Unable to process Bible text');
    }
    if (type === 'passages') {
        const parser = new DOMParser();
        const doc = parser.parseFromString(res.data.content, 'text/html');
        const span = doc.getElementsByClassName('verse-span');
        let lastVerse;
        for (const verse of span) {
            const currVerse = verse.getAttribute('data-verse-id');
            if (currVerse !== lastVerse) {
                lastVerse = verse.getAttribute('data-verse-id');
                if (verse.textContent)
                    result.push(verse.textContent);
            }
            else {
                // join 'separated' words in verse
                // result[result.length - 1] += ' ' + verse.textContent;
                if (verse.textContent) {
                    result[result.length - 1] = `${result[result.length - 1]} ${verse.textContent}`;
                }
            }
        }
    }
    return result;
};

class BibleUp {
    // PRIVATE_FIELD
    #element;
    #options;
    #defaultOptions;
    #regex;
    #mouseOnPopup; // if mouse is on popup
    #popupTimer;
    #loadingTimer;
    #currentRef; // currently loading bible ref
    #activeLink; // unique identifier of last clicked link
    #popup;
    #ispopupOpen;
    #events;
    #initKey; // unique bibleup instance key
    constructor(element, options) {
        this.#element = element;
        this.#defaultOptions = {
            version: 'KJV',
            popup: 'classic',
            darkTheme: false,
            bu_ignore: ['H1', 'H2', 'H3', 'H4', 'H5', 'H6', 'A'],
            bu_allow: [],
            buid: false,
            ignoreCase: false,
            styles: {}
        };
        if (typeof options === 'object' && options !== null) {
            this.#options = this.#mergeOptions(false, this.#defaultOptions, options);
        }
        else {
            this.#options = this.#defaultOptions;
        }
        this.#initKey = Math.floor(Math.random() * (999999 - 100000) + 100000).toString();
        this.#init(this.#options);
        this.#regex = this.#generateRegex();
        this.#mouseOnPopup = false;
        this.#ispopupOpen = false;
        this.#events = {
            clickHandler: this.#clickHandler.bind(this),
            closePopup: this.#closePopup.bind(this),
            exitPopup: this.#exitPopup.bind(this)
        };
    }
    /**
     * Returns BibleUp Options for present class instance
     * @returns {Options}
     */
    get getOptions() {
        return this.#options;
    }
    /**
     * Returns buid for a BibleUp Instance. This can either be the buid specified in Options or private initKey of instance
     * @returns {string}
     */
    get #buid() {
        return this.#options.buid || this.#initKey;
    }
    /**
     * Activates a BibleUp instance.
     */
    create() {
        this.#searchNode(this.#element, this.#regex.main);
        this.#manageEvents();
    }
    /**
     * This method destoys BibleUp instance and removes the links and popup from the page
     * @param force - Specify whether to totally destroy bibleup instance, and refresh() won't work anymore. when set to false, this will preserve popup container and bibleup tagging can be resumed with refresh() method
     */
    destroy(force = true) {
        const links = document.querySelectorAll(`.bu-link-${this.#buid}`);
        for (const link of links) {
            const cite = link.closest('cite');
            if (cite) {
                const ref = cite.getAttribute('bu-ref');
                if (ref)
                    cite.replaceWith(ref);
            }
        }
        if (force === true && this.#popup.container) {
            this.#popup.container.remove();
            this.#initKey = '';
        }
    }
    /**
     * Merges defaultOptions and newOptions to form a new BibleUp.options Object if force is true,
     * else it updates BibleUp.options with any changes in newOptions.
     * @param force If true, merges defaultOptions and newOptions; otherwise, updates BibleUp.options.
     * @param defaultOptions Default options to merge.
     * @param newOptions Partial options to merge.
     * @returns Merged options object.
     */
    #mergeOptions(force, oldOptions, new0ptions) {
        if (force) {
            //return { ...this.#defaultOptions, ...new0ptions }
            return this.#mergeOptions(false, this.#defaultOptions, new0ptions);
        }
        const mergedOptions = {
            ...oldOptions, // Start with a copy of the old options
            ...new0ptions, // Overwrite with properties from the new options
            styles: {
                ...oldOptions.styles, // Merge the styles separately
                ...new0ptions.styles // Overwrite with new styles
            },
            bu_ignore: [...oldOptions.bu_ignore, ...(new0ptions.bu_ignore || [])], // Merge bu_ignore arrays
            bu_allow: [...oldOptions.bu_allow, ...(new0ptions.bu_allow || [])] // Merge bu_allow arrays
        };
        return mergedOptions;
    }
    /**
     * Modifies the options of a BibleUp instance
     * @param options New BibleUp Options
     * @param element The new element to search, if specified; else, the element specified during BibleUp
     * instantiation will be searched again
     * @param force If false, previous BibleUp options will be merged with new options passed.
     * If force is set to true, the options passed into this method will totally overwrite previous options
     */
    refresh(options = {}, force = false, element = this.#element) {
        if (!this.#initKey) {
            this.#error('cannot call refresh on an uncreated or destroyed BibleUp instance');
        }
        const old = this.#options;
        const trigger = { version: false, popup: false, style: false };
        this.#options = this.#mergeOptions(force, old, options);
        // trigger version
        if (old.version !== this.#options.version) {
            trigger.version = true;
        }
        // trigger build popup
        if (old.popup !== this.#options.popup ||
            old.darkTheme !== this.#options.darkTheme ||
            old.buid !== this.#options.buid) {
            this.#popup.container?.remove();
            trigger.popup = true;
            trigger.style = true;
        }
        // change link class if buid changes
        if (old.buid !== this.#options.buid) {
            const oldKey = old.buid || this.#initKey;
            const bulink = document.querySelectorAll(`.bu-link-${oldKey}`);
            bulink.forEach((link) => {
                link.classList.replace(`bu-link-${oldKey}`, `bu-link-${this.#buid}`);
            });
        }
        // trigger styles
        if (JSON.stringify(old.styles) !== JSON.stringify(this.#options.styles)) {
            trigger.style = true;
        }
        // change this.#regex if ignoreCase changes
        if (old.ignoreCase !== this.#options.ignoreCase) {
            this.#regex = this.#generateRegex();
        }
        this.#searchNode(element, this.#regex.main);
        // call init() for changes
        if (force) {
            this.#popup.container?.remove();
            this.#init(this.#options);
        }
        else if (trigger.version || trigger.popup || trigger.style) {
            this.#init(this.#options, trigger);
        }
        this.#manageEvents();
    }
    /**
     * @param {Object} options BibleUp Options
     * @param {*} trigger Optional - define what to trigger init on
     */
    #init(options, trigger = { version: true, popup: true, style: true }) {
        if (trigger.version && options.version) {
            const versions = supportedVersions.all;
            if (versions.includes(options.version.toUpperCase()) === false) {
                this.#error('The version in BibleUp options is currently not supported. Try with other supported versions');
            }
        }
        if (trigger.popup && options.popup) {
            const popup = ['classic', 'inline', 'wiki'];
            if (popup.includes(options.popup)) {
                this.#popup = build(options, this.#buid);
            }
            else {
                this.#error("BibleUp was unable to construct popup. Check to see if 'popup' option is correct");
            }
        }
        if (trigger.style &&
            this.#options.styles &&
            Object.keys(this.#options.styles).length !== 0) {
            this.#setStyles(this.#options.styles);
        }
    }
    #setStyles(styles) {
        const { container, header, version, close } = this.#popup;
        const props = ['borderRadius', 'boxShadow', 'fontSize'];
        for (const prop of props) {
            const value = styles[prop];
            if (value) {
                container.style[prop] = value;
            }
        }
        if (styles.primary) {
            container.style.background = styles.primary;
        }
        if (styles.fontColor) {
            container.style.color = styles.fontColor;
        }
        if (header) {
            if (styles.secondary) {
                header.style.background = styles.secondary;
            }
            if (styles.headerColor) {
                header.style.color = styles.headerColor;
            }
        }
        if (version) {
            if (styles.tertiary) {
                version.style.background = styles.tertiary;
            }
            if (styles.versionColor) {
                version.style.color = styles.versionColor;
            }
        }
        if (close && styles.closeColor) {
            close.style.color = styles.closeColor;
        }
    }
    /**
     * This generates the BibleUp regex. The regex test can be tested here:
     * @returns Object of Type `Regex` containing main regex and standalone verse regex
     */
    #generateRegex() {
        const versions = supportedVersions.all.join('|');
        const bookNames = allAbbreviations();
        const main = `(?:(?:(${bookNames.all})(?:\\.?)\\s?(\\d{1,3})(?:\\:\\s?(\\d{1,3}(?:\\s?\\-\\s?\\d{1,3})?))?)(?:[a-zA-Z])?(?:\\s(${versions}))?)(?:\\s?(?:\\,|\\;|\\&)\\s?(?!\\s?(?:${bookNames.multipart})(?:\\.?)\\b)\\s?(?:\\d{1,3}\\s?\\-\\s?\\d{1,3}|\\d{1,3}\\:\\d{1,3}(?:\\-\\d{1,3})?|\\d{1,3})(?:[a-zA-Z](?![a-zA-Z]))?(?:\\s(${versions}))?)*`;
        const verse = `(?:(?:(${bookNames.all})(?:\\.?)\\s?(\\d{1,3})(?:\\:\\s?(\\d{1,3}(?:\\s?\\-\\s?\\d{1,3})?))?)(?:[a-zA-Z])?(?:\\s(${versions}))?)|(\\d{1,3}\\s?\\-\\s?\\d{1,3}|\\d{1,3}\\:\\d{1,3}(?:\\-\\d{1,3})?|\\d{1,3})(?:[a-zA-Z](?![a-zA-Z]))?(?:\\s(${versions}))?`;
        const flags = this.#options.ignoreCase ? 'gi' : 'g';
        return {
            main: new RegExp(main, flags),
            verse: new RegExp(verse, flags)
        };
    }
    /**
     * This function traverse all nodes and child nodes in the `e` parameter
     * - It calls `#createLink()` on all text nodes descendants that matches the Bible regex
     * - The function performs a self call on element child nodes until all text matches are found
     */
    #searchNode(e, regex) {
        if (!e) {
            this.#error('Element does not exist in the DOM');
        }
        const childNodes = Array.from(e.childNodes);
        childNodes.forEach((node) => {
            const type = node.nodeType;
            const match = node.textContent?.match(regex) || false;
            if (type === 3 && match) {
                this.#createLink(node);
            }
            else if (type === 1 && match) {
                // element node
                if (this.#validateNode(node)) {
                    this.#searchNode(node, regex);
                }
            }
        });
    }
    /**
     * This function validates elements node.
     * @returns true after successful validation else returns false
     */
    #validateNode(e) {
        const { bu_ignore: buIgnore, bu_allow: allowedTags } = this.#options;
        const forbiddenTags = [
            ...buIgnore,
            'SCRIPT',
            'STYLE',
            'SVG',
            'IMG',
            'INPUT',
            'TEXTAREA',
            'SELECT'
        ];
        if (forbiddenTags.includes(e.tagName) && !allowedTags.includes(e.tagName)) {
            return false;
        }
        else if (e.classList.contains('bu-ignore')) {
            return false;
        }
        else {
            return true;
        }
    }
    /**
     * Wraps text nodes which matches scripture Regex with `<cite>` element
     * - It replaces 'This text is john 3.16' with 'This text is `<cite>John 3:16</cite>`'
     * @param node - text node
     */
    #createLink(node) {
        const newNode = document.createElement('div');
        const frag = document.createDocumentFragment();
        if (node.nodeValue) {
            newNode.innerHTML = node.nodeValue.replace(this.#regex.main, this.#setLinkMarkup.bind(this));
        }
        if (node.nodeValue !== newNode.innerHTML) {
            const parent = node.parentNode;
            while (newNode.firstChild) {
                frag.appendChild(newNode.firstChild);
            }
            parent?.replaceChild(frag, node);
        }
    }
    /**
     * converts regex match (main) into cite element and regex verse into anchor links
     * Note that the args of this function is from all matches captured by the regex and named accordingly
     * @param {...args} This is the main reference capture groups (p1-pN) - Check replace() on MDN
     * @returns A complete BibleUp Link
     */
    #setLinkMarkup(match, book, chapter, verse, version) {
        const bible = {
            book,
            chapter,
            verse: verse || '1',
            version
        };
        // reference with only chapter and no verse (Romans 8)
        const isChapterLevel = verse === undefined;
        /**
         * Resolves actual chapter and verse number for reference parts
         * References with multiple chapters will overwrite the chapter that will be used for subsequent verses
         * @param verse verse number of main reference
         */
        const vesreContext = (verse) => {
            const result = {};
            if ((verse.includes(':') && verse.includes('-')) || verse.includes(':')) {
                // (in-line chapter with range) or (in-line chapter only)
                result.chapter = verse.slice(0, verse.lastIndexOf(':'));
                result.verse = verse.slice(verse.lastIndexOf(':') + 1);
                bible.chapter = result.chapter;
            }
            else if (isChapterLevel) {
                result.chapter = verse;
                result.verse = '1';
            }
            else {
                result.verse = verse;
            }
            return result;
        };
        /**
         * Returns `bible` object of main reference and each reference parts
         */
        const getBible = (args) => {
            const res = {};
            if (args[0] !== undefined) {
                // main reference
                res.book = bible.book;
                res.chapter = bible.chapter;
                res.verse = bible.verse;
                res.version = bible.version || false;
            }
            else {
                // reference parts
                const { chapter, verse } = vesreContext(args[4]);
                res.book = bible.book;
                res.chapter = chapter || bible.chapter;
                res.verse = verse || bible.verse;
                res.version = args[5] || false;
            }
            const splitedVerse = res.verse
                .split('-')
                .map((item) => item.trim());
            return {
                ...res,
                verse: splitedVerse[0],
                verseEnd: splitedVerse[1]
            };
        };
        /**
         * @desc This breaks the entire string and matches the main reference and every verse ranges and parts separately.
         * Each match is wrapped with an anchor element. The match regex is `this.#regex.verse`
         * Invalid chapter/verse is returned as is.
         * Example: Jn 3:16,17 to <a>Jn 3:16</a>,<a>17</a>
         */
        const str = match.replace(this.#regex.verse, (match, ...args) => {
            const bibleData = getBible(args);
            const buData = this.#validateBible(bibleData);
            return buData === false
                ? match
                : `<a href='#' class='bu-link-${this.#buid}' bu-data='${buData}'>${match}</a>`;
        });
        if (str === match) {
            return match;
        }
        else {
            return `<cite class='bu-link bu-ignore' bu-ref='${match}'>${str}</cite>`;
        }
    }
    /**
     * This will check whether a Bible reference has valid bible verses.
     * @eturns stringified object Type BibleRef if reference is valid, else returns false
     * @param bible - bible is an object {book, chapter, verse, version}
     */
    #validateBible(bible) {
        const bibleRef = extractPassage(bible);
        if (!bibleRef) {
            return false;
        }
        if (bible.version) {
            // add version tagging if present
            bibleRef.version = bible.version;
        }
        for (const data of bibleData) {
            if (data.book === bibleRef.book) {
                if (bibleRef.chapter <= data.chapters.length &&
                    data.chapters[bibleRef.chapter - 1] !== undefined &&
                    bibleRef.verse <= data.chapters[bibleRef.chapter - 1]) {
                    if (bibleRef.verseEnd === undefined ||
                        bibleRef.verseEnd <= data.chapters[bibleRef.chapter - 1]) {
                        return JSON.stringify(bibleRef);
                    }
                }
            }
        }
        //console.log('falsee')
        return false;
    }
    /**
     * Handles Event listener logic on popup
     */
    #manageEvents() {
        const bulink = document.querySelectorAll(`.bu-link-${this.#buid}`);
        // link 'anchor' events
        bulink.forEach((link) => {
            link.removeEventListener('mouseenter', this.#events.clickHandler);
            link.removeEventListener('mouseleave', this.#events.closePopup);
            // prevent scroll behaviour
            link.onclick = (e) => {
                e.preventDefault();
                e.stopPropagation();
            };
            link.addEventListener('mouseenter', this.#events.clickHandler);
            link.addEventListener('mouseleave', this.#events.closePopup);
        });
        this.#popup.container.onmouseenter = () => {
            this.#mouseOnPopup = true;
        };
        this.#popup.container.onmouseleave = (e) => {
            this.#mouseOnPopup = false;
            this.#closePopup(e);
        };
        // close popup events
        if (this.#popup.close) {
            this.#popup.close.removeEventListener('click', this.#events.exitPopup);
            this.#popup.close.addEventListener('click', this.#events.exitPopup);
        }
        window.onkeydown = (e) => {
            if (e.key === 'Escape') {
                if (this.#ispopupOpen) {
                    this.#exitPopup();
                }
            }
        };
    }
    /**
     * Executes event Handler for mouseEnter and click events
     */
    async #clickHandler(e) {
        this.#clearTimer();
        const currentTarget = e.currentTarget;
        const getPosition = (el) => {
            const top = el.getBoundingClientRect().top;
            const left = el.getBoundingClientRect().left;
            return top + left;
        };
        // only update popup if popup is already hidden or different link is clicked than the one active
        if (this.#ispopupOpen === false ||
            this.#activeLink !== getPosition(currentTarget)) {
            this.#activeLink = getPosition(currentTarget);
            const linkData = currentTarget.getAttribute('bu-data');
            const bibleRef = JSON.parse(linkData);
            // add delay before popup 'loading' - to allow fetch return cache if it exists
            this.#loadingTimer = setTimeout(() => {
                this.#updatePopup(bibleRef, true);
                positionPopup(e, this.#options.popup, this.#popup.container);
                this.#openPopup();
            }, 100);
            // call to fetch bible text
            this.#currentRef = bibleRef.ref;
            const res = await getScripture(bibleRef, bibleRef.version ?? this.#options.version);
            if (this.#currentRef === res.ref) {
                // only when cursor is still on same link
                this.#updatePopup(res, false);
                positionPopup(e, this.#options.popup, this.#popup.container);
                if (this.#loadingTimer) {
                    this.#openPopup();
                    clearTimeout(this.#loadingTimer);
                }
            }
        }
    }
    /**
     * Updates popup texts and content
     * @param res Can either be Type BibleRef or BibleFetch depending on isLoading
     * @param isLoading a boolean that makes popup show 'loading' before the bible text is updated. if false, res is Type BibleRef, else, res is Type BibleFetch
     */
    #updatePopup(...args) {
        const [res, isLoading] = args;
        if (isLoading) {
            if (this.#popup.ref) {
                this.#popup.ref.textContent = res.ref;
            }
            if (this.#popup.version) {
                this.#popup.version.textContent =
                    res.version ?? this.#options.version.toUpperCase();
            }
            this.#popup.text.textContent = 'Loading...';
        }
        else {
            if (this.#popup.ref) {
                this.#popup.ref.textContent = res.ref;
                // REF Accessibility
                this.#popup.container.setAttribute('aria-label', `${res.ref}`);
            }
            if (this.#popup.version) {
                this.#popup.version.textContent = res.version;
            }
            this.#popup.text.setAttribute('start', res.refData.startVerse.toString());
            if (res.text == null) {
                this.#popup.text.textContent =
                    'Cannot load bible reference at the moment.';
            }
            else {
                this.#popup.text.innerHTML = '';
                res.text.forEach((verse) => {
                    this.#popup.text.innerHTML += `<li>${verse}</li>`;
                });
            }
        }
    }
    #openPopup() {
        if (!this.#ispopupOpen) {
            this.#popup.container.classList.remove('bu-popup-hide');
            this.#popup.close?.focus();
            this.#ispopupOpen = true;
        }
    }
    /**
     * This attaches a timeout before closing popup
     */
    #closePopup(e) {
        if (!this.#popupTimer) {
            this.#popupTimer = setTimeout(() => {
                if (!this.#mouseOnPopup) {
                    const mouseFrom = e.relatedTarget;
                    if (!mouseFrom ||
                        mouseFrom?.classList.contains(`bu-link-${this.#buid}`) === false) {
                        this.#exitPopup();
                    }
                }
                this.#clearTimer();
            }, 100);
        }
    }
    /**
     * This closes a popup without a timer
     */
    #exitPopup() {
        this.#popup.container.classList.add('bu-popup-hide');
        this.#mouseOnPopup = false;
        this.#ispopupOpen = false;
    }
    #clearTimer() {
        clearTimeout(this.#loadingTimer);
        clearTimeout(this.#popupTimer);
        this.#loadingTimer = undefined;
        this.#popupTimer = undefined;
    }
    #error(msg) {
        throw new Error(msg);
    }
}

export { BibleUp as default };
//# sourceMappingURL=bibleup.esm.js.map
